def get_cpu_pmcs(freq):
    freq = str(freq)
    if freq not in features_per_freq["CPU"]:
        return None
    return features_per_freq["CPU"][freq]
def get_device_pmcs(device:str,freq):
    device = device.upper()
    if device not in features_per_freq:
        raise Exception("Unknown PMCs for device "+device)
    freq = str(freq)
    if freq not in features_per_freq[device]:
        return None
    return features_per_freq[device][freq]

features_per_freq = {
    "CPU": {
        "729600": ["clk","0x8","0x14","0x24"],
        "1190400": ["clk","0x8","0x14","0x24"],
        "2265600": ["clk","0x14","0x24","0x86"]
    },
    "GPU": {
      "624750": [
            "100663390",
            "100663391",
            "100663367",
            "100663366",
            "100663368",
            "100663365",
            "100663314",
            "100663313"],
        "675750": [
            "100663390",
            "100663391",
            "100663367",
            "100663366",
            "100663369",
            "100663368",
            "100663313",
            "100663314"],
        "828750": [
            "100663390",
            "100663391",
            "100663369",
            "100663379",
            "100663367",
            "100663366",
            "100663313",
            "100663314"],
        "905250": [
            "100663390",
            "100663391",
            "100663367",
            "100663366",
            "100663368",
            "100663365",
            "100663313",
            "100663314"],
        "1032750": [
            "100663390",
            "100663391",
            "100663367",
            "100663366",
            "100663368",
            "100663365",
            "100663314",
            "100663313"],
        "1198500": [
            "100663390",
            "100663391",
            "100663367",
            "100663366",
            "100663368",
            "100663365",
            "100663314",
            "100663313"],
        "1236750": [
            "100663390",
            "100663391",
            "100663367",
            "100663366",
            "100663368",
            "100663369",
            "100663314",
            "100663313"],
        "1338750": [
            "100663390",
            "100663391",
            "100663380",
            "100663379",
            "100663367",
            "100663366",
            "100663313",
            "100663314"
        ],
        "1377000": [
            "100663390",
            "100663391",
            "100663369",
            "100663365",
            "100663367",
            "100663366",
            "100663313",
            "100663314"]
    },
    "FPGA": {} #no specific performance counters used for FPGA
}